#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, m, c;
	cin >> n >> m >> c;

    vector<int> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--; r--;

        unordered_map<int, int> m;
        for (int j = l; j <= r; j++) {
            m[v[j]]++;
        }

        int ans = 0;
        for (auto p: m)  {
            if (p.first == p.second) ans++;
        }
        cout << ans << endl;
    }

    return 0;
}
/**
7 3
1 2 2 3 3 3 2
1 7
1 3
4 6
*/
